using System.Data;
using WinFormsLocalDB.PashaCode;

//===========================================================
//        :
// https://www.interestprograms.ru
//     
//===========================================================

namespace WinFormsLocalDB
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Init();
        }

        private void Init()
        {
            string queryString = "SELECT name, database_id as , state_desc as , compatibility_level as [ SQL Server], user_access_desc as [ ], create_date as [ ]  FROM sys.databases;";

            DataTable dataTable = ConnectDB.SqlQuery(queryString);

            dgvDatabase.DataSource = dataTable;
        }

        private void DgvDatabase_RowEnter(object sender, DataGridViewCellEventArgs e)
        {
            dgvDatabase.Tag = dgvDatabase.Rows[e.RowIndex].Cells["name"].Value;

            string queryString = "USE [" + dgvDatabase.Tag + "]; SELECT * FROM INFORMATION_SCHEMA.TABLES";

            DataTable dataTable = ConnectDB.SqlQuery(queryString);

            dgvTables.DataSource = dataTable;
        }

        private void DgvTables_RowEnter(object sender, DataGridViewCellEventArgs e)
        {
            string queryString = "USE [" + dgvDatabase.Tag + "]; SELECT * FROM " + dgvTables.Rows[e.RowIndex].Cells["TABLE_NAME"].Value;

            DataTable dataTable = ConnectDB.SqlQuery(queryString);

            dgvContentTable.DataSource = dataTable;
        }

        private void dgvDatabase_DataError(object sender, DataGridViewDataErrorEventArgs e)
        {
            // ---   ---

            DataGridView? dgv = sender as DataGridView;

            string error = "  ";
            string select = dgv switch
            {
                _ when dgvDatabase == dgv => "dgvDatabase!",
                _ when dgvTables == dgv => "dgvTables!",
                _ when dgvContentTable == dgv => "dgvContentTable!",
                _ => error = " !"
            };

            string coordinateError = "\n" + "row=" + e.RowIndex + ";col=" + e.ColumnIndex + ";";

            MessageBox.Show(error + select + coordinateError + "\n" + e.Exception.Message, "!", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}