﻿using Microsoft.Data.SqlClient;
using System.Data;

//===========================================================
// Подробное описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//===========================================================

namespace WinFormsLocalDB.PashaCode
{
    internal class ConnectDB
    {
        private static string ConnectionString
        {
            get
            {
                var sb = new SqlConnectionStringBuilder
                {
                    DataSource = @"(LocalDB)\MSSQLLocalDB",
                    IntegratedSecurity = true,
                    //InitialCatalog = "DBInternetShop",
                    Pooling = true
                };

                return sb.ConnectionString;
            }
        }

        public static DataTable SqlQuery(string queryString)
        {
            string connectionString = ConnectDB.ConnectionString;

            using SqlConnection connection = new(connectionString); // C# 9.0
            using SqlCommand command = new(queryString, connection); // C# 9.0
            connection.Open();

            DataTable result = new(); // C# 9.0
            using SqlDataReader reader = command.ExecuteReader();
            result.Load(reader);

            return result;
        }
    }
}
